// This class must be fully revised !!!!!!!!!!!!


#include <string>
#include <strstream>
#include <cstdio>
#include <fnmatch.h>
#include "FileSelector.hh"
#include "MustuxLib/MustuxLib.hh"
#include "PrafFile.hh"
#include "WavFile.hh"
#include "Audio.hh"

// FOR LATER :#include "GlobalSettings.hh"


char csFileFilter[100];
char* csFilename;
char* csPath;
int dirListSize;
int fileListSize;
struct dirent **fileList;
struct dirent **dirList;


FileSelector::FileSelector():MustuxWindow()
        {
        build();
        }


FileSelector::~FileSelector()
        {
        unbuild();
        }


int FileSelector::build()
        {
        PENTER;
        MustuxWindow::build();
        GtkWidget *hbox1, *vbox3, *hbox2, *vbox2;
        GtkWidget *scrolledwindow4, *scrolledWindow1, *scrolledwindow5;
        GtkWidget *vseparator1, *hseparator1;
        GtkWidget *label3, *label4, *label1, *label91;

        hbox1 = gtk_hbox_new (false, 0);
        gtk_widget_show (hbox1);
        gtk_box_pack_start (GTK_BOX (box), hbox1, true, true, 0);

        vbox3 = gtk_vbox_new (false, 0);
        gtk_widget_show (vbox3);
        gtk_box_pack_start (GTK_BOX (hbox1), vbox3, true, true, 0);

        hbox2 = gtk_hbox_new (false, 0);
        gtk_widget_show (hbox2);
        gtk_box_pack_start (GTK_BOX (vbox3), hbox2, true, true, 0);

        // the directory list
        scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
        gtk_widget_show (scrolledwindow4);
        gtk_widget_set_usize (scrolledwindow4, 250, 150);
        gtk_box_pack_start (GTK_BOX (hbox2), scrolledwindow4, true, true, 0);

        wDirectories = gtk_clist_new (1);
        gtk_widget_show (wDirectories);
        gtk_container_add (GTK_CONTAINER (scrolledwindow4), wDirectories);
        gtk_clist_set_column_width (GTK_CLIST (wDirectories), 0, 80);
        gtk_clist_column_titles_show (GTK_CLIST (wDirectories));

        label3 = gtk_label_new ("Directories");
        gtk_widget_show (label3);
        gtk_clist_set_column_widget (GTK_CLIST (wDirectories), 0, label3);

        // File list
        scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
        gtk_widget_show (scrolledwindow5);
        gtk_widget_set_usize (scrolledwindow5, 250, 150);
        gtk_box_pack_start (GTK_BOX (hbox2), scrolledwindow5, true, true, 0);

        wFiles = gtk_clist_new (1);
        gtk_widget_show (wFiles);
        gtk_container_add (GTK_CONTAINER (scrolledwindow5), wFiles);
        gtk_clist_set_column_width (GTK_CLIST (wFiles), 0, 80);
        gtk_clist_column_titles_show (GTK_CLIST (wFiles));
        label4 = gtk_label_new ("Files");
        gtk_widget_show (label4);
        gtk_clist_set_column_widget (GTK_CLIST (wFiles), 0, label4);

        // filename and path entries
        label91 = gtk_label_new ("Current Path");
        gtk_widget_show (label91);
        gtk_box_pack_start (GTK_BOX (vbox3), label91, false, false, 0);

        wPathEntry = gtk_entry_new ();
        gtk_editable_set_editable(GTK_EDITABLE(wPathEntry),true);
        gtk_widget_show (wPathEntry);
        gtk_box_pack_start (GTK_BOX (vbox3), wPathEntry, false, false, 0);

        label1 = gtk_label_new ("File");
        gtk_widget_show (label1);
        gtk_box_pack_start (GTK_BOX (vbox3), label1, false, false, 0);

        wFilenameEntry = gtk_entry_new ();
        gtk_editable_set_editable(GTK_EDITABLE(wFilenameEntry),true);
        gtk_widget_show (wFilenameEntry);
        gtk_box_pack_start (GTK_BOX (vbox3), wFilenameEntry, false, false, 0);

        vseparator1 = gtk_vseparator_new ();
        gtk_widget_show (vseparator1);
        gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, false, false, 0);

        vbox2 = gtk_vbox_new (true, 0);
        gtk_widget_show (vbox2);
        gtk_box_pack_start (GTK_BOX (hbox1), vbox2, false, false, 0);

        //buttons
        okButton = gtk_button_new_with_label ("OK");
        gtk_widget_show (okButton);
        gtk_box_pack_start (GTK_BOX (vbox2), okButton, false, false, 10);
        gtk_widget_set_usize (okButton, 80, 25);

        wAutoPlayCheck = gtk_check_button_new_with_label ("Auto-play");
        gtk_widget_show (wAutoPlayCheck);
        gtk_box_pack_start (GTK_BOX (vbox2), wAutoPlayCheck, false, false, 0);

        wAutoInfoCheck = gtk_check_button_new_with_label ("Auto Show Info");
        gtk_widget_show (wAutoInfoCheck);
        gtk_box_pack_start (GTK_BOX (vbox2), wAutoInfoCheck, false, false, 0);

        cancelButton = gtk_button_new_with_label ("CANCEL");
        gtk_widget_show (cancelButton);
        gtk_box_pack_start (GTK_BOX (vbox2), cancelButton, false, false, 0);

        hseparator1 = gtk_hseparator_new ();
        gtk_widget_show (hseparator1);
        gtk_box_pack_start (GTK_BOX (box), hseparator1, false, false, 0);

        // info window
        scrolledWindow1 = gtk_scrolled_window_new (NULL, NULL);
        gtk_widget_show (scrolledWindow1);
        gtk_box_pack_start (GTK_BOX (vbox3), scrolledWindow1, false, false, 0);
        gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(scrolledWindow1),
                                        GTK_POLICY_NEVER,GTK_POLICY_ALWAYS);
        wInfoWindow = gtk_text_new (NULL, NULL);
        gtk_widget_show (wInfoWindow);
        gtk_widget_set_usize (wInfoWindow, -2, 100);
        gtk_container_add (GTK_CONTAINER (scrolledWindow1), wInfoWindow);

        PEXIT;
        return 1;
        }



int FileSelector::init()
        {
        PENTER;
        MustuxWindow::init();
        filename = "";
        currpath = "";
        strcpy(csFileFilter,filefilter.c_str());

        /*
        string s = ".";// FOR LATER :GlobalSettings::get_last_path();
        change_dir(s);
        */

        isAutoPlayOn=false;
        isAutoInfoOn=false;
        isPlaying = false;
        isFileSelected = false;
        fill_dirs();
        fill_files();

        gtk_widget_set_sensitive(wAutoPlayCheck,isAutoPlayOn);
        gtk_widget_set_sensitive(wAutoInfoCheck,isAutoInfoOn);
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wAutoPlayCheck),isAutoPlayOn);
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wAutoInfoCheck),isAutoInfoOn);

        gtk_signal_connect(GTK_OBJECT(okButton),"clicked", GTK_SIGNAL_FUNC (on_ok), this);
        gtk_signal_connect(GTK_OBJECT(cancelButton),"clicked", GTK_SIGNAL_FUNC (on_cancel), this);
        gtk_signal_connect(GTK_OBJECT(wFilenameEntry),"activate", GTK_SIGNAL_FUNC(on_ok), this);
        gtk_signal_connect(GTK_OBJECT(wFiles),"select_row", GTK_SIGNAL_FUNC (on_file_selected), this);
        gtk_signal_connect(GTK_OBJECT(wDirectories),"select_row", GTK_SIGNAL_FUNC (on_dir_selected), this);
        gtk_signal_connect(GTK_OBJECT(wAutoPlayCheck), "toggled", GTK_SIGNAL_FUNC (on_autoplay_toggled),this);
        gtk_signal_connect(GTK_OBJECT(wAutoInfoCheck), "toggled", GTK_SIGNAL_FUNC (on_autoplay_toggled),this);
        gtk_signal_connect(GTK_OBJECT(wFilenameEntry),"changed", GTK_SIGNAL_FUNC(on_filename_entry_changed), this);
        gtk_signal_connect(GTK_OBJECT(wPathEntry),"activate", GTK_SIGNAL_FUNC(on_path_entered), this);

        gtk_main();
        PEXIT;
        return 1;
        }



int FileSelector::finalize()
        {
        PENTER;
        MustuxWindow::finalize();
        gtk_main_quit();
        char *cw = new char[4096];
        cw = getcwd(cw, (size_t) 4096);
        delete cw;
        // FOR LATER :GlobalSettings::set_last_path(cw);
        PEXIT;
        return 1;
        }


int FileSelector::unbuild()
        {
        PENTER;
        MustuxWindow::unbuild();
        PEXIT;
        return 1;
        }



string FileSelector::get()
        {
        PENTER;
        filefilter = "*.*"; // TEMPORARY
        init();
        PEXIT;
        return filename;
        }



void FileSelector::change_dir(string newDir) // MAKE ME BETTER PLEASE!!
        {
        PFLOODENTER;
        string s = "./";
        s.append(newDir);
        // TODO : test if newdir exists
        if (1)
                {
                chdir(s.c_str());
                char *cw = new char[4096];
                cw = getcwd(cw, (size_t) 4096);
                currpath = cw;
                }
        else
                {
                PMESG("Directory not found");
                return;
                }
        gtk_clist_clear(GTK_CLIST(wFiles));
        gtk_clist_clear(GTK_CLIST(wDirectories));
        delete dirList;
        delete fileList;
        fill_dirs();
        fill_files();
        PFLOODEXIT;
        }




void FileSelector::fill_files()
        {
        PFLOODENTER;
        char* b[1];
        read_files();
        for (int i=0; i< fileListSize; i++)
                {
                b[0] = fileList[i]->d_name;
                //PMESG("Adding file " << b);
                gtk_clist_append(GTK_CLIST(wFiles), b);
                }
        PFLOODEXIT;
        }



void FileSelector::fill_dirs()
        {
        PFLOODENTER;
        read_dirs();
        char* b[1];
        for (int i=0; i< dirListSize; i++)
                {
                b[0] = dirList[i]->d_name;
                //PMESG("Adding directory " << b);
                gtk_clist_append(GTK_CLIST(wDirectories), b);
                }
        PFLOODEXIT;
        }



int FileSelector::read_files()
        {
        PFLOODENTER;
        fileListSize = scandir(".", &fileList, match, alphasort);
        if (fileListSize==0)
                {
                PFLOODEXIT;
                return -1;
                }
        PFLOODEXIT;
        return 1;
        }



int FileSelector::read_dirs()
        {
        PFLOODENTER;
        dirListSize = scandir(".", &dirList, isdir, alphasort);
        if (dirListSize!=0)
                {
                PFLOODEXIT;
                return -1;
                }
        PFLOODEXIT;
        return 1;
        }


void FileSelector::get_info()
        {
        PFLOODENTER;
        string o;
        ostrstream os;
        PrafFile* pf;
        o = string(csFilename) + "\n";
        gtk_text_insert (GTK_TEXT (wInfoWindow), standardFont, NULL, NULL, o.c_str(), o.length());

        switch (type)
                {
                case Audio::PRAF:
                        {
                        pf = new PrafFile();
                        pf->open(string(csFilename));
                        pf->read_header();
                        channels = pf->get_channels();
                        rate = pf->get_rate();
                        bitDepth = pf->get_bit_depth();
                        if (isAutoInfoOn)
                                {
                                o = "   Project "+pf->get_project_label()+", ";
                                gtk_text_insert (GTK_TEXT (wInfoWindow), standardFont, NULL, NULL, o.c_str(), o.length());
                                                o = "	Group "+pf->get_group_label() +" , ";
                                                gtk_text_insert (GTK_TEXT (wInfoWindow), standardFont, NULL, NULL, o.c_str(), o.length());
                                o = "   Hardware "+pf->get_hardware_label()+ " \n";
                                                gtk_text_insert (GTK_TEXT (wInfoWindow), standardFont, NULL, NULL, o.c_str(), o.length());
                                o = "   Description: " + pf->get_description() + "\n";
                                                gtk_text_insert (GTK_TEXT (wInfoWindow), standardFont, NULL, NULL, o.c_str(), o.length());
                                }
                        delete pf;
                        break;
                        }
                case Audio::WAV:
                        {
                        /*
                        wf = new WavFile();
                        wf->open(string(csFilename));
                        wf->read_header();
                        channels = wf->channels;
                        rate = wf->rate;
                        bitDepth = wf->bitDepth;
                        delete wf;
                        break;
                        */
                        }
                case Audio::MPEG3:
                case Audio::OGGVORBIS :
                        {
                        rate = 44100;
                        channels = 2;
                        bitDepth = 16;
                        break;
                        }
                }
        if (isAutoInfoOn)
                {
                if (channels==1) os << "	Mono, ";
                else
                if (channels==2) os << "	Stereo, ";
                else os << channels << " channels, ";
                os << rate << " Hz " << bitDepth << " bits\n" << ends;
                o = os.str();
                gtk_text_insert (GTK_TEXT (wInfoWindow), standardFont, NULL, NULL, o.c_str(), o.length());
                gtk_text_thaw(GTK_TEXT(wInfoWindow));
                }
        PFLOODEXIT;
        }




int FileSelector::play_fragment(gpointer obj)
        {
        FileSelector *o = (FileSelector*) obj;
        fread(o->audioFrag, o->audioFragSize, 1, o->file);
        if (feof(o->file))
                rewind(o->file);
        o->dsp->play_fragment(o->audioFrag, o->audioFragSize);
        return 1;
        }



int FileSelector::start_playing()
        {
        if (!isFileSelected)
                return -1;
        dsp = new Dsp();
        file = fopen(csFilename,"r");
        if (dsp->open_for_play()<0)
                {
                delete dsp;
                PEXIT;
                return -1;
                }
        if (dsp->set(channels , rate , bitDepth)<0)
                {
                delete dsp;
                PEXIT;
                return -1;
                }
        if (dsp->set_format(Dsp::S16_LE)<0)
                {
                delete dsp;
                PEXIT;
                return -1;
                }
        audioFragSize = dsp->get_best_fragment_size();
        audioFrag = new char[audioFragSize];
        playTimeTag = gtk_timeout_add( 5, play_fragment, this );
        isPlaying = true;
        return 1;
        }


int FileSelector::restart_playing()
        {
        stop_playing();
        start_playing();
        return 1;
        }


int FileSelector::stop_playing()
        {
        isPlaying = false;
        gtk_timeout_remove(playTimeTag);
        dsp->close();
        fclose(file);
        delete audioFrag;
        delete dsp;
        return 1;
        }


int FileSelector::match(const struct dirent *e)
        {
        //!!!! instead of 16, right below, I tried put the flag constant
        //!!!! FNM_CASEFOLD, as indicated in "man fnmatch" and "<fnmatch.h>"
        //!!!! It just doesnt compile!!! If you find out the reason, please
        //!!!! email-me (giordana at canada dot com)
        return (fnmatch(csFileFilter,e->d_name, 16 )==0);
        }



        
int FileSelector::isdir(const struct dirent *e)
        {
        static struct stat stf;
        return ((stat(e->d_name,&stf)==0) && (S_ISDIR(stf.st_mode)));
        }




// callbacks
int FileSelector::on_ok(GtkWidget* w, FileSelector *o)
        {
        if (o->isPlaying) o->stop_playing();
        o->filename = string(csFilename);
        o->finalize();
        return 1;
        }


int FileSelector::on_cancel(GtkWidget* w, FileSelector *o)
        {
        if (o->isPlaying) o->stop_playing();
        o->filename = "";
        o->finalize();
        return 1;
        }



int FileSelector::on_dir_selected(GtkCList *clist,  int row, int column,  GdkEventButton *event, FileSelector *o)
        {
        if (row==0)
                return 1; // "."
        if (row==1)
                {
                o->change_dir("..");
                }
        else
                {
                string s = "./";
                s.append(dirList[row]->d_name);
                o->change_dir(s);
                }
        gtk_clist_clear(GTK_CLIST(o->wFiles));
        gtk_clist_clear(GTK_CLIST(o->wDirectories));
        delete dirList;
        delete fileList;
        o->fill_dirs();
        o->fill_files();
        return 1;
        }



int FileSelector::on_file_selected(GtkCList *clist,  int row, int column,  GdkEventButton *event, FileSelector *o)
        {
        PENTER;
        csFilename = fileList[row]->d_name;
        gtk_entry_set_text(GTK_ENTRY(o->wFilenameEntry), (const char*) csFilename);
        o->filename = csFilename;
        PMESG("Current file selected is : " << o->filename << " in " << o->currpath);
        o->isFileSelected = true;
        if (o->isAutoInfoOn)
                o->get_info();
        if (o->isAutoPlayOn)
                {
                if (o->isPlaying)
                o->restart_playing();
                else
                o->start_playing();
                }
        // if (event->type==GDK_2BUTTON_PRESS) o->ok();
        PEXIT;
        return 1;
        }



int FileSelector::on_filename_entry_changed(GtkWidget* w, FileSelector* o)
        {
        csFilename = gtk_entry_get_text(GTK_ENTRY(o->wFilenameEntry));
        return 1;
        }



int FileSelector::on_path_entered(GtkWidget* w, FileSelector *o)
        {
        csPath = gtk_entry_get_text(GTK_ENTRY(o->wFilenameEntry));
        return 1;
        }


int FileSelector::on_autoplay_toggled(GtkToggleButton *togglebutton, FileSelector* o)
        {
        o->isAutoPlayOn = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(o->wAutoPlayCheck));
        if ((o->isAutoPlayOn) && (o->isFileSelected))
                o->start_playing();
        if ((!o->isAutoPlayOn) && (o->isPlaying))
                o->stop_playing();
        return 1;
        }

// eof

