#include "MustuxEngine.hh"
#include "MustuxDebugger.hh"
#include <string>

MustuxEngine::MustuxEngine()
    {
    }

MustuxEngine::~MustuxEngine()
    {
    }

int MustuxEngine::init(MustuxInterface *aMustuxInterface)
    {
    PENTER;
    interface = aMustuxInterface;
    output = aMustuxInterface->get_default_lcd();
    PEXIT;
    return 1;
    }

int MustuxEngine::finalize()
    {
    PENTER;
    PEXIT;
    return 1;
    }


void MustuxEngine::print( string s, int  line)
    {
    PFLOODENTER;
    output->print( s, line );
    PFLOODEXIT;
    }


//



