#include <string>
#include <cstdio>
#include "MustuxInfoWindow.hh"


MustuxInfoWindow::MustuxInfoWindow():MustuxDialog()
    {
    }


MustuxInfoWindow::~MustuxInfoWindow()
    {
    }


int MustuxInfoWindow::build()
    {
    MustuxDialog::build();

    scrolledWindow = gtk_scrolled_window_new (NULL, NULL);
    gtk_widget_show (scrolledWindow);
    gtk_box_pack_start (GTK_BOX (box), scrolledWindow, TRUE, TRUE, 0);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledWindow),
                                    GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

    wText = gtk_text_new (NULL, NULL);
    gtk_widget_set_usize (wText, 500, 300);
    gtk_container_add (GTK_CONTAINER (scrolledWindow), wText);
    gtk_widget_show (wText);
    gtk_widget_realize (wText);
    return 1;
    }


int MustuxInfoWindow::init()
    {
    MustuxDialog::init();
    return 1;
    }


int MustuxInfoWindow::finalize()
    {
    MustuxDialog::finalize();
    return 1;
    }



int MustuxInfoWindow::unbuild()
    {
    MustuxDialog::unbuild();
    return 1;
    }


void MustuxInfoWindow::print(string mesg)
    {
    gtk_text_insert (GTK_TEXT (wText), standardFont, NULL, NULL, (char*) mesg.c_str(), mesg.length());
    gtk_text_thaw (GTK_TEXT (wText));
    while (gtk_events_pending())
        gtk_main_iteration();
    }


void MustuxInfoWindow::print(int value)
    {
    char strdata[18]; // mess!!! mudar para string e strstream
    sprintf(strdata,"%d",value);
    gtk_text_insert (GTK_TEXT (wText), standardFont, NULL, NULL, strdata, strlen(strdata));
    gtk_text_thaw (GTK_TEXT (wText));
    while (gtk_events_pending())
        gtk_main_iteration();
    }


void MustuxInfoWindow::print(long value)
    {
    char strdata[18]; // mess!!! mudar para string e strstream
    sprintf(strdata,"%10ld",value);
    gtk_text_insert (GTK_TEXT (wText), standardFont, NULL, NULL, strdata, strlen(strdata));
    gtk_text_thaw (GTK_TEXT (wText));
    while (gtk_events_pending()) gtk_main_iteration();
    }



void MustuxInfoWindow::print(char value)
    {
    char c[2];
    c[0]=value;
    c[1]=0;
    gtk_text_insert (GTK_TEXT (wText), standardFont, NULL, NULL, c, 1);
    gtk_text_thaw (GTK_TEXT (wText));
    while (gtk_events_pending())
        gtk_main_iteration();
    }

void MustuxInfoWindow::mark()
    {
    markPos = gtk_text_get_point(GTK_TEXT(wText));
    }


void MustuxInfoWindow::back()
    {
    gtk_text_backward_delete (GTK_TEXT(wText), gtk_text_get_point(GTK_TEXT(wText))-markPos);
    gtk_text_thaw(GTK_TEXT(wText));
    }

//eof

