#ifndef INFOWINDOW_HH
#define INFOWINDOW_HH

#include <gtk/gtk.h>
#include <string>
#include "MustuxDialog.hh"

class MustuxInfoWindow : public MustuxDialog
        {
        public:
                MustuxInfoWindow();
                ~MustuxInfoWindow();
                int build();
                int init();
                int finalize();
                int unbuild();
                void print(string data);
                void print(int data);
                void print(long value);
                void print(char value);
                void mark();
                void back();
                void set_title(string title);

        private:
                GtkWidget *wText;
                GtkWidget* scrolledWindow;
                int markPos;
        };

#endif


//eof


