#include <iostream.h>
#include <string.h>
#include "MustuxJogMouseBoardEvent.hh"
#include "MustuxDebugger.hh"

MustuxJogMouseBoardEvent::MustuxJogMouseBoardEvent()
    {
    }

MustuxJogMouseBoardEvent::~MustuxJogMouseBoardEvent()
    {
    }


int MustuxJogMouseBoardEvent::get_action_type() const
    {
    return actionType;
    }

int MustuxJogMouseBoardEvent::get_press1_key1() const
    {
    return key1A;
    }

int MustuxJogMouseBoardEvent::get_press1_key2() const
    {
    return key2A;
    }

int MustuxJogMouseBoardEvent::get_press2_key1() const
    {
    return key1B;
    }

int MustuxJogMouseBoardEvent::get_press2_key2() const
    {
    return key2B;
    }


bool MustuxJogMouseBoardEvent::use_X_axis() const
    {
    return useX;
    }

bool MustuxJogMouseBoardEvent::use_Y_axis() const
    {
    return useY;
    }

bool MustuxJogMouseBoardEvent::use_grab() const
    {
    return useGrab;
    }


void MustuxJogMouseBoardEvent::set(string newActionName ,
                                   int newActionType,
                                   int newKey1A,
                                   int newKey2A,
                                   int newKey1B,
                                   int newKey2B,
                                   bool newUseX,
                                   bool newUseY,
                                   bool newUseGrab)
    {
    actionName = newActionName;
    actionType = newActionType;
    key1A = newKey1A;
    key2A = newKey2A;
    key1B = newKey1B;
    key2B = newKey2B;
    useX = newUseX;
    useY = newUseY;
    useGrab = newUseGrab;
    isImmediate = false;
    }


void MustuxJogMouseBoardEvent::set_immediate(bool status)
        {
        isImmediate = status;
        }

bool MustuxJogMouseBoardEvent::is_immediate()
        {
        return isImmediate;
        }

// EOF


