#ifndef JOGMOUSEBOARDEVENT_HH
#define JOGMOUSEBOARDEVENT_HH

#include <string>

class MustuxJogMouseBoardEvent // This class should be named "MustuxJogMouseBoardAction"
    {
    private:
        int actionType;
        int key1A;
        int key2A;
        int key1B;
        int key2B;
        bool useX;
        bool useY;
        bool useGrab;
        bool isImmediate;


    public:
        string actionName;

        MustuxJogMouseBoardEvent();
        ~MustuxJogMouseBoardEvent();
        int get_action_type() const;
        int get_press1_key1() const;
        int get_press1_key2() const;
        int get_press2_key1() const;
        int get_press2_key2() const;

        bool use_X_axis() const;
        bool use_Y_axis() const;
        bool use_grab() const;
        void set(string actioname,
                int type,
                int key1A,
                int key2A,
                int key1B,
                int key2B,
                bool useX,
                bool useY ,
                bool useGrab);
        void set_immediate(bool status);
        bool is_immediate();
    };


#endif

// eof

