#include <gtk/gtk.h>
#include <gdk/gdk.h>
//#include <gdk_imlib.h>
#include <cstdio>
#include <string>
#include <iostream>
#include "AudioSourcesWindow.hh"
#include "MustuxLib/MustuxLib.hh"


AudioSourcesWindow::AudioSourcesWindow():MustuxWindow()
    {
    PENTERCONS;
    PEXITCONS;
    }

AudioSourcesWindow::~AudioSourcesWindow()
    {
    PENTERDES;
    PEXITDES;
    }

int AudioSourcesWindow::build(int h, int w)
        {
        MustuxWindow::build(h,w,MustuxComponent::RESIZEABLE);

        GtkWidget* scrolledWindow = gtk_scrolled_window_new (0, 0);
        gtk_widget_show (scrolledWindow);
        gtk_widget_set_usize (scrolledWindow, 250, 150);
        gtk_box_pack_start (GTK_BOX (box), scrolledWindow, true, true, 0);

        GtkWidget* wList = gtk_clist_new (1);

        gtk_widget_show (wList);
        gtk_container_add (GTK_CONTAINER (scrolledWindow), wList);
        gtk_clist_set_column_width (GTK_CLIST (wList), 0, 80);
        gtk_clist_column_titles_show (GTK_CLIST (wList));

        GtkWidget* label = gtk_label_new ("Audio Sources");
        gtk_widget_show (label);
        gtk_clist_set_column_widget (GTK_CLIST (wList), 0, label);

        char* s = "NOT IMPLEMENTED";
        gtk_clist_append(GTK_CLIST(wList), &s);

        return 1;
        }

int AudioSourcesWindow::init()
    {
    MustuxWindow::init();
    set_title("Audio Sources");
    return 1;
    }

int AudioSourcesWindow::finalize()
    {
    MustuxWindow::finalize();
    return 1;
    }

int AudioSourcesWindow::unbuild()
    {
    MustuxWindow::unbuild();
    return 1;
    }


// eof

