#ifndef MULTITRACKPANEL_HH
#define MULTITRACKPANEL_HH

#include "MustuxLib/MustuxLib.hh"

class TrackPanel;

class MultiTrackPanel : public MustuxComponent
    {

    public:
        static const int MAX_TRACKS = 32;

        MultiTrackPanel(GtkWidget* aParentBox);
        ~MultiTrackPanel();

        int build(int aTotalTracks);
        int init();

        TrackPanel* trackPanel[MAX_TRACKS];
        int totalTracks;

    };

#include "TrackPanel.hh"


#endif
