#ifndef LCD_DIGITS_HH
#define LCD_DIGITS_HH

#define MAXSYMBOLS 59

char digit[MAXSYMBOLS][8][6] =
        {
                { // space
                "00000",
                "00000",
                "00000",
                "00000",
                "00000",
                "00000",
                "00000",
                "00000"},
                { // !
                "00000",
                "00100",
                "00100",
                "00100",
                "00100",
                "00100",
                "00000",
                "00100"},
                { // "
                "00000",
                "01010",
                "01010",
                "00000",
                "00000",
                "00000",
                "00000",
                "00000"},
                { // #
                "00000",
                "01010",
                "01000",
                "11111",
                "01010",
                "11111",
                "01010",
                "01010"},
                { // $
                "00100",
                "01110",
                "10001",
                "01100",
                "00110",
                "00001",
                "01110",
                "00100"},
                { // %
                "00000",
                "01000",
                "10101",
                "01010",
                "00100",
                "01010",
                "10101",
                "00010"},
                { // &
                "00000",
                "01110",
                "10001",
                "01000",
                "01100",
                "10100",
                "10010",
                "01101"},
                { // '
                "00000",
                "00100",
                "00100",
                "00000",
                "00000",
                "00000",
                "00000",
                "00000"},
                { // (
                "00010",
                "00100",
                "01000",
                "01000",
                "01000",
                "01000",
                "00100",
                "00010"},
                { // )
                "01000",
                "00100",
                "00010",
                "00010",
                "00010",
                "00010",
                "00100",
                "01000"},
                { // *
                "00000",
                "00100",
                "10101",
                "01110",
                "11111",
                "01110",
                "10101",
                "00100"},
                { // +
                "00000",
                "00000",
                "00100",
                "00100",
                "11111",
                "00100",
                "00100",
                "00000"},
                { // ,
                "00000",
                "00000",
                "00000",
                "00000",
                "00000",
                "00000",
                "00100",
                "01000"},

                { // -
                "00000",
                "00000",
                "00000",
                "00000",
                "01110",
                "00000",
                "00000",
                "00000"},
                { // .
                "00000",
                "00000",
                "00000",
                "00000",
                "00000",
                "00000",
                "00000",
                "00100"},
                { // /
                "00000",
                "00010",
                "00010",
                "00100",
                "00100",
                "01000",
                "01000",
                "00000"},
                { // 0
                "00000",
                "00100",
                "01010",
                "10001",
                "10001",
                "10001",
                "01010",
                "00100"},
                { // 1
                "00000",
                "00100",
                "01100",
                "00100",
                "00100",
                "00100",
                "00100",
                "01110"},
                { // 2
                "00000",
                "01110",
                "10001",
                "00001",
                "00110",
                "01000",
                "10000",
                "11111"},
                { // 3
                "00000",
                "01110",
                "10001",
                "00001",
                "00110",
                "00001",
                "10001",
                "01110"},
                {// 4
                "00000",
                "00110",
                "01010",
                "10010",
                "11110",
                "00010",
                "00010",
                "00111"},
                {// 5
                "00000",
                "11111",
                "10000",
                "10000",
                "11110",
                "00001",
                "10001",
                "01110"},
                { // 6
                "00000",
                "01110",
                "10001",
                "10000",
                "11110",
                "10001",
                "10001",
                "01110"},
                { //7
                "00000",
                "11111",
                "00001",
                "00010",
                "00100",
                "00100",
                "00100",
                "00100"},
                { // 8
                "00000",
                "01110",
                "10001",
                "10001",
                "01110",
                "10001",
                "10001",
                "01110"},
                { // 9
                "00000",
                "01110",
                "10001",
                "10001",
                "01111",
                "00001",
                "00001",
                "01110"},
                { // :
                "00000",
                "00000",
                "00000",
                "00100",
                "00000",
                "00100",
                "00000",
                "00000"},
                { // ;
                "00000",
                "00000",
                "00000",
                "00100",
                "00000",
                "00100",
                "00100",
                "01000"},
                { // <
                "00000",
                "00010",
                "00100",
                "01000",
                "10000",
                "01000",
                "00100",
                "00010"},
                { // =
                "00000",
                "00000",
                "00000",
                "01110",
                "00000",
                "01110",
                "00000",
                "00000"},
                { // >
                "00000",
                "01000",
                "00100",
                "00010",
                "00001",
                "00010",
                "00100",
                "01000"},
                { // ?
                "00000",
                "01110",
                "10001",
                "00001",
                "00010",
                "00100",
                "00000",
                "00100"},
                { // @
                "00000",
                "01111",
                "10001",
                "10011",
                "10101",
                "10011",
                "10000",
                "01110"},
                { // A
                "00000",
                "00100",
                "01010",
                "10001",
                "10001",
                "11111",
                "10001",
                "10001"},
                {
                "00000",
                "11110",
                "10001",
                "10001",
                "11110",
                "10001",
                "10001",
                "11110"},
                {
                "00000",
                "01110",
                "10001",
                "10000",
                "10000",
                "10000",
                "10001",
                "01110"},
                {
                "00000",
                "11110",
                "10001",
                "10001",
                "10001",
                "10001",
                "10001",
                "11110"},
                {
                "00000",
                "11111",
                "10000",
                "10000",
                "11110",
                "10000",
                "10000",
                "11111"},
                {
                "00000",
                "11111",
                "10000",
                "10000",
                "11110",
                "10000",
                "10000",
                "10000"},
                {
                "00000",
                "01110",
                "10001",
                "10000",
                "10011",
                "10001",
                "10001",
                "01110"},
                {
                "00000",
                "10001",
                "10001",
                "10001",
                "11111",
                "10001",
                "10001",
                "10001"},
                {
                "00000",
                "01110",
                "00100",
                "00100",
                "00100",
                "00100",
                "00100",
                "01110"},
                {
                "00000",
                "00111",
                "00010",
                "00010",
                "00010",
                "10010",
                "10010",
                "01100"},
                {
                "00000",
                "10001",
                "10010",
                "10100",
                "11000",
                "10100",
                "10010",
                "10001"},
                {
                "00000",
                "10000",
                "10000",
                "10000",
                "10000",
                "10000",
                "10000",
                "11111"},
                {
                "00000",
                "10001",
                "11011",
                "10101",
                "10101",
                "10001",
                "10001",
                "10001"},
                {
                "00000",
                "10001",
                "11001",
                "10101",
                "10101",
                "10011",
                "10001",
                "10001"},
                {
                "00000",
                "01110",
                "10001",
                "10001",
                "10001",
                "10001",
                "10001",
                "01110"},
                {
                "00000",
                "11110",
                "10001",
                "10001",
                "11110",
                "10000",
                "10000",
                "10000"},
                {
                "00000",
                "01110",
                "10001",
                "10001",
                "10001",
                "10001",
                "10010",
                "01101"},
                {
                "00000",
                "11110",
                "10001",
                "10001",
                "11110",
                "10100",
                "10010",
                "10001"},
                {
                "00000",
                "01110",
                "10001",
                "10000",
                "01110",
                "00001",
                "10001",
                "01110"},
                {
                "00000",
                "11111",
                "00100",
                "00100",
                "00100",
                "00100",
                "00100",
                "00100"},
                {
                "00000",
                "10001",
                "10001",
                "10001",
                "10001",
                "10001",
                "10001",
                "01110"},
                {
                "00000",
                "10001",
                "10001",
                "10001",
                "10001",
                "10001",
                "01010",
                "00100"},
                {
                "00000",
                "10001",
                "10001",
                "10001",
                "10101",
                "10101",
                "01010",
                "01010"},
                {
                "00000",
                "10001",
                "10001",
                "01010",
                "00100",
                "01010",
                "10001",
                "10001"},
                {
                "00000",
                "10001",
                "10001",
                "01010",
                "00100",
                "00100",
                "00100",
                "00100"},
                {
                "00000",
                "11111",
                "00001",
                "00010",
                "00100",
                "01000",
                "10000",
                "11111"},
        };

#endif

//eof


