#ifndef MUSTUXCONFIRMWINDOW_HH
#define MUSTUXCONFIRMWINDOW_HH

#include <gtk/gtk.h>
#include <string>
#include "MustuxDialog.hh"

class MustuxConfirmWindow  : public MustuxDialog
    {
    public :
        MustuxConfirmWindow();
        ~MustuxConfirmWindow();
        int build();
        int init();
        int finalize();
        int unbuild();
        bool get_answer(string message);

    private :
        GtkWidget *yesButton;
        GtkWidget *noButton;
        bool answer;


        // callbacks
        static int on_yes(GtkWidget *w, MustuxConfirmWindow* c);
        static int on_no(GtkWidget *w, MustuxConfirmWindow* c);

    };

#endif

//eof

