#include "MustuxDebugger.hh"

static int ntabs = 0;
static bool debugOn = true;
static bool floodDebugOn = false;


void MustuxDebugger::fill_tabs()
    {
    for (int i=0; i < ntabs; i++) cout << "    ";
    }

void MustuxDebugger::more_tabs()
    {
    ntabs++;
    }

void MustuxDebugger::less_tabs()
    {
    ntabs--;
    }

void MustuxDebugger::set_debug_on()
        {
        debugOn = true;
        }

void MustuxDebugger::set_debug_off()
        {
        debugOn = false;
        }

void MustuxDebugger::set_flood_debug_on()
        {
        floodDebugOn = true;
        }

void MustuxDebugger::set_flood_debug_off()
        {
        floodDebugOn = false;
        }

bool MustuxDebugger::is_debug_on()
        {
        return debugOn;
        }

bool MustuxDebugger::is_flood_debug_on()
        {
        return floodDebugOn;
        }

//eof

