#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <string>
#include <cstdio>
#include <string>
#include <iostream>
#include "MustuxHelpWindow.hh"
#include "MustuxDebugger.hh"
// FOR LATER #include "SettingsManager.hh"


MustuxHelpWindow::MustuxHelpWindow():MustuxDialog()
    {
    }


MustuxHelpWindow::~MustuxHelpWindow()
    {
    }


void MustuxHelpWindow::build()
	{
	PENTER;
    MustuxDialog::build();

	string helpFilename = "help.text";// fOR LATER GlobalSettings::get_root_path() + "MustuxHelp.text";
	PMESG("MustuxHelp file = " << helpFilename);

	scrolledWindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledWindow);
	gtk_box_pack_start (GTK_BOX (box), scrolledWindow, true, true, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledWindow),
                                    GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	text = gtk_text_new (NULL, NULL);
	gtk_widget_show (text);
	gtk_container_add (GTK_CONTAINER (scrolledWindow), text);
	gtk_widget_set_usize(text,600,400);
	gtk_widget_realize (text);
	gtk_text_freeze (GTK_TEXT (text));

	helpFile = fopen(helpFilename.c_str(), "r");
	if (helpFile)
		{
		char buffer[1024];
		int nchars;
		while (true)
			{
			nchars = fread(buffer, 1, 1024, helpFile);
			gtk_text_insert (GTK_TEXT (text), standardFont, NULL, NULL, buffer, nchars);
			if (nchars < 1024)
				break;
			}
		fclose (helpFile);
		}
	else
		{
		PERROR("Cannot open MustuxHelp.text");
		}
	gtk_text_thaw (GTK_TEXT (text));

//?
/*	box = gtk_hbutton_box_new ();
	gtk_widget_show (box);
	gtk_box_pack_start (GTK_BOX (vbox), box, false, false, 10);

	ok_button = gtk_button_new_with_label ("OK");
	gtk_widget_show (ok_button);
	gtk_box_pack_start (GTK_BOX (box), ok_button, false, false, 0);
	gtk_widget_set_usize (ok_button, 90, 20);
*/
    PEXIT;
	}



	
//eof


