#include <iostream>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk_imlib.h>
#include "MustuxDebugger.hh"
#include "MustuxKernel.hh"


void MustuxKernel::init(int argc, char *argv[])
        {
        PENTER;
        gtk_init(&argc, &argv);
        gdk_imlib_init();
        PEXIT;
        }


void MustuxKernel::set_kb_repeat(bool status)
        {
        if (status)
                {
                PMESG("Allowing keyboard repetition");
                gdk_key_repeat_restore();
                }
        else
                {
                PMESG("Disabling keyboard repetition");
                gdk_key_repeat_disable();
                }
        }

void MustuxKernel::flush_events()
        {
	while (gtk_events_pending())
                gtk_main_iteration();
        }

// eof

