#ifndef PROGRESSBAR_HH
#define PROGRESSBAR_HH

#include <gtk/gtk.h>
#include <string>
#include "MustuxWindow.hh"
#include "MustuxPane.hh"
#include "MustuxComponent.hh"

class MustuxProgressBar : public MustuxWindow
        {
        public:
                MustuxProgressBar();
                ~MustuxProgressBar();

                int build();
                int init(string title);
                int finalize();
                int unbuild();
                void update();
                void set_label(string label);
                void configure(float min, float max, float init);
                void set_value(float v);
        private:
                GtkWidget *wLabel;
                MustuxComponent* barContainer;
                MustuxPane* bar;
                float min, max, curr, lastCurr;
                int updateTag;

        };
#endif

// eof
