#ifndef PRAFSETTINGSWINDOW_HH
#define PRAFSETTINGSWINDOW_HH


#include <gtk/gtk.h>

class PrafSettingsWindow
	{
	private:
		GtkWidget *window;
		GtkWidget *ok_button;
		GtkWidget *cancel_button;
		GtkWidget *combo_entry1;
		GtkWidget *combo_entry2;
		GtkWidget *combo_entry3;
		GtkWidget *entry1;
		GtkWidget *entry2;
		GtkWidget *entry3;	
		GtkWidget *text_desc;
		string project_label;
		string group_label;
		string hardware_label;
		string description_label;
		int nchannels;	
		int rate;
		int bit_depth ;
		bool cancelled;
		
	public:
		PrafSettingsWindow();
		~PrafSettingsWindow();
		void show();
		bool get();
		void ok();
		void cancel();
		void hide();
		void end_loop();
		string get_project_label();
		string get_group_label();
		string get_hardware_label();
		string get_description_label();
		int get_rate();
		int get_nchannels();
		int get_bit_depth();
	};

#endif


//eof

