#ifndef TRACKPANEL_HH
#define TRACKPANEL_HH

#include "MustuxLib/MustuxLib.hh"

class TrackPanel : public MustuxPane
        {
        public :
                TrackPanel(MustuxComponent* aParent);
                ~TrackPanel();
                int build(int w, int h);
                int init();
                void recreate();
                void clear();
                void activate();
                void deactivate();
                void set_track_number(int i);
        private :
                int trackNumber;
        };


#endif


//eof

